from graphics_and_games_klassen import Rechteck, Figur
import time

class ZaunSued(Rechteck):
    """
    Der Zaun als Hindernis.
    """
    def __init__(self):
        super().__init__()
        self.FarbeSetzen("braun")
        self.PositionSetzen(0, 490)
        self.GroesseSetzen(600, 10)


class ZaunOst(Rechteck):
    """
    Der Zaun als Hindernis.
    """
    def __init__(self):
        super().__init__()
        self.FarbeSetzen("braun")
        self.PositionSetzen(590, 0)
        self.GroesseSetzen(10, 500)


class ZaunNord(Rechteck):
    """
    Der Zaun als Hindernis.
    """
    def __init__(self):
        super().__init__()
        self.FarbeSetzen("braun")
        self.PositionSetzen(0, 0)
        self.GroesseSetzen(600, 10)


class ZaunWest(Rechteck):
    """
    Der Zaun als Hindernis.
    """
    def __init__(self):
        super().__init__()
        self.FarbeSetzen("braun")
        self.PositionSetzen(0, 0)
        self.GroesseSetzen(10, 500)


class Rasen(Rechteck):
    """
    Die Rasenfläche.
    """
    def __init__(self):
        super().__init__()
        self.FarbeSetzen("grün")
        self.PositionSetzen(0, 10)
        self.GroesseSetzen(600, 490)


class Blume(Figur):
    """
    Stellt eine Blume im Rasen dar.
    """
    def __init__(self):
        """
        Konstruktor für Objekte der Klasse Blume
        """
        super().__init__()
        self.GroesseSetzen(20)
        self.FigurteilFestlegenEllipse(-50, -50, 100, 100, "rot")
        self.PositionSetzen(300, 300)

    def AktionAusfuehren(self):
        """
        Wird bei jedem Schritt des Mähroboters automatisch ausgeführt
        """
        pass
        
class Maehroboter(Figur):
    """
    Der Mähroboter geht gerade aus, bis er auf einen Zaun trifft (braunes Hindernis).
    """
    def __init__(self):
        super().__init__()
        self.FigurteilFestlegenRechteck(-50, -40, 20, 10, "schwarz")
        self.FigurteilFestlegenRechteck(-50, 30, 20, 10, "schwarz")
        self.FigurteilFestlegenRechteck(30, -40, 20, 10, "schwarz")
        self.FigurteilFestlegenRechteck(30, 30, 20, 10, "schwarz")
        self.FigurteilFestlegenEllipse(-50, -40, 100, 80, "cyan")
        self.FigurteilFestlegenDreieck(5, -10, 45, 0, 5, 10, "rot")

        self.PositionSetzen(300, 400)
        self.Drehen(90)
        self.batteriestand = 500

        Rasen()
        ZaunNord()
        ZaunWest()
        ZaunOst()
        ZaunSued()
        Blume()
        self.GanzNachVornBringen()

    def BisZaunMaehen(self):
        """
        Mäht so lange, so lange kein Hindernis kommt.
        """
        while not self.BeruehrtFarbe("braun"):
            self.EinenSchrittMaehen()

    def GrundstueckMaehen(self):
        """
        Mäht das gesamte Grundstück
        """
        # Hier ergänzen
        self.BisZaunMaehen()
        self.Gehen(-30)
        self.Drehen(170)

    def EinenSchrittMaehen(self):
        """
        Simulation des Mähvorgangs.
        """
        self.Gehen(5)
        self.MaehspurDarstellen()
        self.BatteriestandUm1Reduzieren()
        print("Batteriestand", self.BatteriestandGeben())

    def BatteriestandGeben(self):
        """
        Meldet den Batteriestand.
        :returns: Batteriestand
        """
        return self.batteriestand

    def BatteriestandUm1Reduzieren(self):
        """
        Erhöht den Batteriestand um 1.
        """
        self.batteriestand -= 1

    def MaehspurDarstellen(self):
        """
        Im Anzeigefenster eine Mähspur darstellen.
        """
        r = Rechteck()
        r.FarbeSetzen("hellgrün")
        if 45 < self.WinkelGeben() <= 135:
            r.GroesseSetzen(20, 5)
            r.PositionSetzen(self.XPositionGeben() - 10, self.YPositionGeben() + 25)
        elif 135 < self.WinkelGeben() <= 225:
            r.GroesseSetzen(5, 20)
            r.PositionSetzen(self.XPositionGeben() - 25, self.YPositionGeben() - 10)
        elif 225 < self.WinkelGeben() <= 315:
            r.GroesseSetzen(20, 5)
            r.PositionSetzen(self.XPositionGeben() - 10, self.YPositionGeben() - 35)
        else:
            r.GroesseSetzen(5, 20)
            r.PositionSetzen(self.XPositionGeben() + 25, self.YPositionGeben() - 10)

        self.GanzNachVornBringen()
        try:
            time.sleep(0.05)
        except InterruptedError:
            pass

    def Drehen(self, grad):
        """
        Drehen und den Drehwinkel im Intervall [0;360[ halten.
        """
        super().Drehen(grad)
        if self.WinkelGeben() >= 360:
            self.WinkelSetzen(self.WinkelGeben() - 360)
        elif self.WinkelGeben() < 0:
            self.WinkelSetzen(self.WinkelGeben() + 360)


m = Maehroboter()
m.GrundstueckMaehen()