# -- coding: utf-8 --
"""
Created on Wed Apr  8 17:53:04 2020
@author: Klaus Reinold
"""

from graphics_and_games_klassen import Rechteck, Figur
from intern.zeichenfenster import Zeichenfenster

class Ausgang(Rechteck):
    """
    Der Ausgang
    """
    
    def __init__(self):
        """
        Konstruktor
        """    
        super().__init__()
        self.PositionSetzen(14*50+15+1,8*50+20+1)
        self.GroesseSetzen(48,48)
        self.FarbeSetzen("grün")
        
class MauerHorizontal(Rechteck):
    """
    Eine horizontale Mauer
    """
    
    def __init__(self, x, y, breite):
        """
        Konstruktor
        -- Parameter x 0<=x<=15
        -- Parameter y 0<=y<=9
        -- Parameter breite x+breite <=15
        """    
        super().__init__()
        self.PositionSetzen(x*50+15-1,y*50+20-1)
        self.GroesseSetzen(breite*50+2, 2)
        self.FarbeSetzen("schwarz")
        
class MauerVertikal(Rechteck):
    """
    Eine vertikale Mauer
    """
    
    def __init__(self, x, y, höhe):
        """
        Konstruktor
        -- Parameter x 0<=x<=15
        -- Parameter y 0<=y<=9
        -- Parameter breite x+höhe <=9
        """  
        super().__init__()
        self.PositionSetzen(x*50+15-1,y*50+20-1)
        self.GroesseSetzen(2, 2+höhe*50)
        self.FarbeSetzen("schwarz")
        
class Labyrinth:
    """
    Klasse zur Beschreibung des Labyrinths
    """
    
    def __init__(self):
        """
        Legt die Mauern an und positioniert den Ausgang
        """    
        MauerHorizontal(0,0,15)
        MauerHorizontal(3,1,3)
        MauerHorizontal(8,1,3)
        MauerHorizontal(13,1,1)
        MauerHorizontal(2,2,4)
        MauerHorizontal(12,2,1)
        MauerHorizontal(3,3,3)
        MauerHorizontal(11,3,2)
        MauerHorizontal(3,4,2)
        MauerHorizontal(12,4,2)
        MauerHorizontal(2,5,4)
        MauerHorizontal(8,5,2)
        MauerHorizontal(13,5,2)
        MauerHorizontal(1,6,10)
        MauerHorizontal(0,7,10)
        MauerHorizontal(1,8,10)
        MauerHorizontal(0,9,15)
        MauerVertikal(0,0,9)
        MauerVertikal(1,1,5)
        MauerVertikal(2,0,5)
        MauerVertikal(3,3,1)
        MauerVertikal(6,1,1)
        MauerVertikal(6,3,2)
        MauerVertikal(7,0,2)
        MauerVertikal(7,3,3)
        MauerVertikal(8,1,4)
        MauerVertikal(9,1,3)
        MauerVertikal(10,2,3)
        MauerVertikal(11,1,7)
        MauerVertikal(12,0,2)
        MauerVertikal(12,4,5)
        MauerVertikal(13,2,1)
        MauerVertikal(13,5,3)
        MauerVertikal(14,1,3)
        MauerVertikal(14,6,3)
        MauerVertikal(15,0,8)
        Ausgang()
        
class Spielfigur(Figur):
    """
    Spielfigur
    """
    
    def __init__(self):
        """
        Legt die Form und die Startposition der Spielfigur fest
        """    
        super().__init__()
        self.FigurteilFestlegenEllipse(-50, -50, 100, 100, "rot")
        self.delta = 1
        self.PositionSetzen(338,143)
        
### Hier die fehlenden Methoden einbauen.
        
    def TasteGedrueckt(self, taste):
        """
        Wird aufgerufen, wenn eine Pfeiltaste gedrückt wurde
        -- Parameter taste Bezeichnung der Taste
        """    
        if taste == "left": 
            self.NachLinksBewegen() 
        elif taste == "up":
            self.NachObenBewegen() 
        elif taste == "right":
            self.NachRechtsBewegen() 
        elif taste == "down":
            self.NachUntenBewegen()
            
class Spiel:
    def __init__(self):
        Labyrinth()
        Spielfigur()
        
Spiel()