# -- coding: utf-8 --
"""
Created on Wed Apr  8 17:53:04 2020
@author: Klaus Reinold
"""

from graphics_and_games_klassen import Rechteck, Figur

class Zelle(Rechteck):
    """
    Der Zaun als Hindernis.
    """
    
    def __init__(self, xLinksOben, yLinksOben, farbeNeu):
        """
        Platziert eine Zelle
        """    
        super().__init__()
        self.PositionSetzen(xLinksOben, yLinksOben)
        self.GroesseSetzen(46, 46)
        self.FarbeSetzen(farbeNeu)
        
class Blume(Figur):
    """
    Blume, die darauf wartet, gesammelt zu werden.
    """
    
    def __init__(self, xNeu = 4, yNeu = 2):
       """
       Der Konstruktor2 erzeugt eine Blume in einem Spielfeld mit 10x10 Zellen.
       --Parameter xNeu  x-Position der Blume
       --Parameter yNeu  y-Position der Blume
       """    
       super().__init__()
       self.FigurteilFestlegenEllipse(0, 0, 25, 25, "gelb")
       self.FigurteilFestlegenEllipse(0, -20, 20, 20, "weiss")
       self.FigurteilFestlegenEllipse(20, -10, 20, 20, "weiss")
       self.FigurteilFestlegenEllipse(20, 10, 20, 20, "weiss")
       self.FigurteilFestlegenEllipse(0, 20, 20, 20, "weiss")
       self.FigurteilFestlegenEllipse(-20, -10, 20, 20, "weiss")
       self.FigurteilFestlegenEllipse(-20, 10, 20, 20, "weiss")
       self.GanzNachVornBringen()
       if(xNeu<10 and xNeu>=0 and yNeu<10 and yNeu>=0):
             self.PositionSetzen(xNeu*50 +25, yNeu*50 +25)
             
class Florian(Figur):
    """
    Die Spielfigur der Blumenwelt.
    """
    
    def __init__(self):
        """
        Legt die Form und die Startposition fest.
        """    
        super().__init__()
        self.FigurteilFestlegenRechteck(-20, -15, 40, 60, "orange")
        self.FigurteilFestlegenEllipse(-10, -50, 20, 30, "orange")
        self.FigurteilFestlegenDreieck(0, 0, 0, 30, 18, 15, "gelb")
        self.PositionSetzen(75, 125)
        self.GanzNachVornBringen()
        
    def NachOstenGehen(self):
        """
        Lässt Florian eine Zelle nach Osten gehen.
        """    
        self.PositionSetzen(self.XPositionGeben()+50, self.YPositionGeben())
        
    def NachWestenGehen(self):
        """
        Lässt Florian eine Zelle nach Westen gehen.
        """    
        self.PositionSetzen(self.XPositionGeben()-50, self.YPositionGeben())
        
    def NachSüdenGehen(self):
        """
        Lässt Florian eine Zelle nach Süden gehen.
        """    
        self.PositionSetzen(self.XPositionGeben(), self.YPositionGeben()+50)
        
    def NachNordenGehen(self):
        """
        Lässt Florian eine Zelle nach Norden gehen.
        """
        self.PositionSetzen(self.XPositionGeben(), self.YPositionGeben()-50)
        
    def LinksDrehen(self):
        """
        Dreht sich um 90 Grad nach links
        Tipp: Teste vorab (an einem Objekt der Klasse Florian) 
        die Methoden Drehen, WinkelGeben, WinkelSetzen der Oberklasse
        """    
        self.WinkelSetzen(self.WinkelGeben()+90)
        
    def RechtsDrehen(self):
        """
        Dreht sich um 90 Grad nach rechts
        Tipp: Teste vorab (an einem Objekt der Klasse Florian) 
        die Methoden Drehen, WinkelGeben, WinkelSetzen der Oberklasse
        """    
        self.WinkelSetzen(self.WinkelGeben()-90)
        
class Blumenwelt:
    """
    Legt die Blumenwelt an und die nicht beweglichen Objekte. 
    """
    
    def __init__(self):
        """
        Baut das Szenario auf.
        """    
        #Diesen Abschnitt ignorieren, es werden die 10x10 Zellen der Welt erzeugt und positioniert
        for zellenNummerX in range(0, 10):
            for zellenNummerY in range(0, 10):
                Zelle(50*zellenNummerX+2, 50*zellenNummerY+2, "grün")
        #Abschnittsende
        nummer = 2; # Nummer ist ein Platzhalter für eine Zahl. Startwert 2 für die Nummer
        while (nummer < 10):
            Blume(nummer, 2)
            nummer = nummer +1 # die Nummer wird um eins erhöht
